import { ClsHookedStrategy } from 'src/session-strategy/cls-hooked-strategy'
import { SessionStrategy } from 'src/session-strategy/session-strategy'

export class NodeSessionUtil {
	protected readonly _strategy: SessionStrategy

	constructor(props?: { sessionStrategy?: SessionStrategy }) {
		const { sessionStrategy = new ClsHookedStrategy() } = props ?? {}
		this._strategy = sessionStrategy
	}

	createAsyncSession<T = any>(callback: () => Promise<T>): Promise<T> {
		return new Promise((resolve, reject) => {
			this._strategy.createSession(() => {
				callback().then(resolve).catch(reject)
			})
		})
	}

	createSession(callback: () => void): void {
		this._strategy.createSession(callback)
	}
}
